function [ W0_best, Ws, Is ] = MMI_Max_With_Diff_Inits(d,...
						  Xs_big,k_big,...
						  Xs_sml,k_sml,Jp_sml)
% 
% Written by:
% -- 
% John L. Weatherwax                2005-11-12
% 
% email: wax@alum.mit.edu
% 
% Please send comments and especially bug reports to the
% above email address.
% 
%-----

%icChoices = { 'PCA', 'LDA', 'RAND', 'RAND', 'RAND', 'UNIT' }; 
icChoices = { 'PCA', 'LDA', 'RAND', 'RAND', 'RAND' }; 
d_lda_max = length(unique(k_big))-1; 
if( d > d_lda_max ) icChoices(2) = []; end
Is = []; Ws = cell(length(icChoices)); 
for ii=1:length(icChoices),
  disp( [ 'Projecting with ', icChoices{ii}, '...' ] ); 
  [ Ys, W0 ] = initialProjection(Xs_big,k_big,d,icChoices{ii});
  
  method=3;
  switch method,
   case 1 % stochastic gradient
    [ Ys, W, I ] = MMI_SG(Xs_sml,k_sml,Jp_sml,d,W0);
   case 2 % theta parameterization
    eta = 100.0; nIter = 30; useIC = 0; 
    [ Ys, W, I ] = MMI(Xs_sml,k_sml,Jp_sml,d,W0,eta,nIter,useIC);
   case 3 % matrix parameterization
    [ Ys, W, I ] = MMI_matrix_param(Xs_sml,k_sml,Jp_sml,d,W0);
   otherwise
    error( 'Unknown value of method' ); 
  end
  
  % dm: [ Ys, W, I ] = MMI_SG(Xs_sml,k_sml,Jp_sml,d,W0);
  Is = [ Is; I ]; Ws{ii} = W; 
  
  if( 1 )
    % Plot the results: 
    cs = { 'yo', 'g*', 'bd', 'rs', 'bx', 'm+' }; 
    figure; 
    for i=1:length(unique(k_sml))
      inds=find(k_sml==i);
      plot( -Ys(inds,1), Ys(inds,2), cs{i} ); 
      if( i==1 ) hold on; end
    end
    axis( [ -3.5 3.5 -3.5 3.5 ] ); grid on; drawnow; 
    title( [ 'Final Projected LandSat Data: ', icChoices{ii} ] ); 
  end
  
end
Is
[ dum, midx ] = max(Is); 
W0_best = Ws{midx};
