function [ dICdY, dITdY, IC, IT ] =  computeInformationGradients(Ys,k,sgma,Jp)
%
% Outputs Eq 28 and 29.
%
% 
% Written by:
% -- 
% John L. Weatherwax                2005-10-30
% 
% email: wax@alum.mit.edu
% 
% Please send comments and especially bug reports to the
% above email address.
% 
%-----

[ VCY2, VC2Y2, VCY ] = computeInformationPotentials(Ys,k,Jp,sgma); 

[ DVCY2, DVC2Y2, DVCY ] = computeInformationForces(Ys,k,Jp,sgma);

dICdY = (1/VCY2) * DVCY2 + (1/VC2Y2) * DVC2Y2 - (2/VCY) * DVCY;

dITdY = DVCY2 + DVC2Y2 - 2 * DVCY;

% Reshape to pass out: 
dICdY = dICdY.';
dITdY = dITdY.';

IC = log( (VCY2*VC2Y2)/(VCY^2) );
IT = VCY2 + VC2Y2 - 2*VCY; 

