function [ Ys, W0 ] = initialProjection(Xs,k,d,InitChoice)
% 
% 
% Written by:
% -- 
% John L. Weatherwax                2005-11-12
% 
% email: wax@alum.mit.edu
% 
% Please send comments and especially bug reports to the
% above email address.
% 
%-----

D = size(Xs,2);

switch lower(InitChoice)
 case { 'pca' }                               % With PCA (using all the data):
  [ Ys, W0 ] = PCA( Xs.' ); 
  W0 = W0(:,1:d);  
  Ys = Ys.'; 
 case { 'mda', 'lda' }                        % With MDA (using all the data):
  [ Ys, W0 ] = MDA( Xs.', k ); 
  W0 = W0(:,1:d); 
  Ys = Ys.'; 
 case { 'rand' }                              % Randomly
  %randn('seed',0); 
  W0 = randn(D,d); W0 = gram(W0);
  Ys = Xs * W0; 
 case { 'unit' }
  W0 = ones(D,d);
  Ys = Xs * W0; 
 otherwise
  error( 'Unknown value of InitChoice' ); 
end
